// dodela.h - Klasa dodele vrednosti.

#ifndef _dodela_h_
#define _dodela_h_

#include "izraz.h"
#include "prom.h"

namespace Izrazi {
  class Dodela: public Izraz {
  private:
    Prom* a; Izraz* b;                        // Operandi.
    void pisi(ostream& it) const              // Pisanje.
      { it << '(' << *a << '=' << *b << ')'; }
    void kopiraj(const Dodela& d)             // Kopiranje u objekat.
      { a = d.a->kopija(); b = d.b->kopija(); }
    void brisi() { delete a; delete b; }      // Oslobadanje memorije.
  public:
    Dodela(const Prom& x, const Izraz& y)     // Inicijalizacija izrazima.
      { a = x.kopija(); b = y.kopija(); }
    Dodela(const Dodela& op) { kopiraj(op); } // Konstruktor kopije.
    ~Dodela() { brisi(); }                    // Destruktor.
    Dodela& operator=(const Dodela& y) {      // Dodela vrednosti.
      if (this != &y) { brisi(); kopiraj(y); }
      return *this;
    }
    double vredn() const { return (*a = *b).vredn(); }    // Vrednost.
    Dodela* kopija() const { return new Dodela (*this); } // Kopiranje.
  }; // class Dodela
} // namespace Izrazi;

#endif
