// fun3.h - Apstraktna klasa funkcija i klasa delegata.

#ifndef _fun3_h_
#define _fun3_h_

#include <iostream>
using namespace std;

namespace Izvodi {
  class Delegat;  // Deklaracija klase delegata.

  class Fun {                                 // DEFINICIJA KLASE FUNKCIJA:
  public:
    ~Fun() {}                                // Virtuelan destruktor.
    virtual double operator()(double x) const =0; // Racunanje vrednosti.
    virtual Delegat izvod() const =0;        // Stvaranje izvoda.
    virtual Fun* kopija() const =0;          // Kopiranje.
  private:
    virtual void pisi(ostream& it) const =0; // Pisanje.
    friend ostream& operator<<(ostream& it, const Fun& f)
      { f.pisi(it); return it; }
  }; // class Fun
 
  class Delegat: public Fun {                 // DEFINICIJA KLASE DELEGATA:
    Fun* f;                                          // Sadrana funkcija.
    void pisi(ostream& it) const { it << *f; }       // Pisanje.
  public:
    Delegat(Fun* ff) { f = ff; }                     // Inicijalizacija.
    Delegat(const Delegat& d) { f = d.f->kopija(); } // Konstruktor kopije.
    ~Delegat() { delete f; }                         // Destruktor.
    Delegat& operator=(const Delegat& d) {           // Dodela vrednosti.
      if (this != &d) { delete f; f = d.f->kopija(); }
      return *this;
    }
    double operator()(double x) const { return (*f)(x); }  // Vrednost.
    Delegat izvod() const { return f->izvod(); }     // Stvaranje izvoda.
    Delegat* kopija() const { return new Delegat(*this); } // Kopiranje.
  }; // class Delegat
} // namespace Izvodi

#endif
