// grupa.h - Klasa grupe elektricnih potroaca.

#ifndef _grupa_h_
#define _grupa_h_

#include "potrosac1.h"
#include <iostream>
using namespace std;

namespace Potrosaci {
  class Grupa: public Potrosac {
    struct Elem {                            // Element liste potroaca.
      Potrosac* potr; Elem* sled;
      Elem(Potrosac* p) { potr = p; sled = 0; }
      ~Elem() { delete potr; }
    };
    Elem *prvi, *posl;                       // Prvi i poslednji element.
    double sna;                              // Snaga grupe.
    void kopiraj(const Grupa& g);            // Kopiranje u objekat.
    void brisi();                            // Brisanje objekta.
    void pisi(ostream& it) const;            // Pisanje.
  public:
    Grupa() { prvi = posl = 0; }             // Stvaranje prazne grupe.
    Grupa(const Grupa& g) { kopiraj(g); }    // Konstruktor kopije.
    ~Grupa() { brisi(); }                    // Destruktor.
    Grupa& operator=(const Grupa& g) {       // Dodela vrednosti.
      if (this != &g) { brisi(); kopiraj(g); }
      return *this;
    }
    Grupa& operator+=(const Potrosac& p) {   // Dodavanje potroaca.
      Elem* novi = new Elem(p.kopija());
      posl = (!prvi ? prvi : posl->sled) = novi;
      sna += p.snaga(); return *this;
    }
    double snaga() const { return sna; }     // Snaga grupe.
    Grupa* kopija() const                    // Kopiranje.
      { return new Grupa(*this); }
  }; // class
} // namespace

#endif
