// inventar.h - Klasa inventara.

#include "zapis.h"
#include <iostream>
using namespace std;

class Inventar {
  Zapis** niz;  // Niz pokazivaca na zapise.
  int kap, duz; // Kapacitet i duina niza.
  void kopiraj(const Inventar& inv);               // Kopiranje u objekat.
  void brisi();                                    // Brisanje objekta.
public:
  explicit Inventar(int k=10)                      // Stvaranje objekta.
    { niz = new Zapis* [kap = k]; duz = 0; }
  Inventar(const Inventar& inv) { kopiraj(inv); }  // Konstruktor kopije.
  ~Inventar() { brisi(); }                         // Destruktor.
  Inventar& operator=(const Inventar& inv) {       // Dodela vrednosti.
    if (this != &inv) { brisi(); kopiraj(inv); }
    return *this;
  }
  int duzina() const { return duz; }               // Duina niza.
                                                   // Dohvatanje zapisa:
  Zapis* operator[](const char* naziv);            // - iz promenljivog,
  const Zapis* operator[](const char* naziv) const // - iz nepromenljivog
    {return const_cast<Inventar&>(*this)[naziv]; } // objekta.
  bool operator+=(Zapis* z) {                      // Dodavanje zapisa.
    if (duz==kap || (*this)[z->naziv()]) return false;
    niz[duz++] = z; return true;
  }
  double vrednost() const;                         // Vrednost svih artikala
  friend ostream& operator<<(ostream& it, const Inventar& inv); // Pisanje.
};
