// izvor.C  Metode i funkcije uz klasu izvora elektricne energije.

#include "izvor.h"

namespace Potrosaci {
  Izvor::Izvor(double s, int k) {               // Inicijalizacija.
    niz = new Potrosac* [kap = k];
    for (int i=0; i<kap; niz[i++]=0); sna = s; opt = 0;
  }

  Izvor::~Izvor()                               // Destruktor.
    { for (int i=0; i<kap; delete niz[i++]); delete [] niz; }

  Izvor& Izvor::prikljuci(Potrosac* p, int i) { // Prikljucivanje potroaca.
    if (i<0 || i>= kap) throw GIndeks();
    if (niz[i]) { opt-=niz[i]->snaga(); delete niz[i]; niz[i]=0; }
    if (p) {
      double s = p->snaga();
      if (opt+s > sna) throw GPreopt();
      niz[i] = p; opt += s;
    }
    return *this;
  }

  ostream& operator<<(ostream& it, const Izvor& izv) { // Pisanje.
    it << '\n' << izv.opt << '/' << izv.sna << endl;
    for (int i=0; i<izv.kap; i++) {
      it << i << ": ";
      if (izv.niz[i]) it << *izv.niz[i]; else it << "<< prazan >>";
      it << endl;
    }
    return it;
  }
} // namespce
