// kamion.h - Klasa kamiona.

#ifndef _kamion_h_
#define _kamion_h_

#include "vozilo3.h"
#include <iostream>
using namespace std;

class GPretovaren {};              // KLASA GREKE: Kamion je pretovaren.
inline ostream& operator<<(ostream& it, const GPretovaren&) {
  return it << "*** Kamion je pretovaren! ***"; }

class Kamion: public Vozilo {      // KLASA KAMIONA:
  float nos, tov;                  // Nosivost i trenutna teina tovara.
public:
  Kamion(float sTez, float ns): Vozilo(sTez)  // Stvaranje praznog kamiona.
    { nos = ns; tov = 0; }
  const char* vrsta() const{ return "Kamion"; } // Naziv vrste vozila.
  float tezina() const { return Vozilo::tezina() + tov; } // Teina vozila.
  Kamion& operator+=(float tovar){              // Dodavanje tovara.
    if (tov+tovar > nos) throw GPretovaren();
    tov += tovarv;
    return *this;
  }
  Kamion& operator-=(float tovar) {             // Skidanje tovara.
    tov -= tovar;
    if (tov<0) tov = 0;
    return *this;
  }
private:
  void pisi(ostream& it)                        // Pisanje.
    { Vozilo::pisi(it); it << ' ' << tov; }
};

#endif
