// lista5.h - Klasa neuredenih listi celih brojeva.

#ifndef _lista5_h_
#define _lista5_h_

#include <iostream>
using namespace std;

class NLista {
protected:
  struct Elem {               // ELEMENT LISTE:
    int broj; Elem* sled;     // - sadraj i pokazivac na sledeci element,
    Elem(int b, Elem* s=0)    // - konstruktor.
      { broj = b; sled = s; }
  };
  Elem *prvi, *posl;                 // Prvi i poslednji element liste.
  int duz;                           // Duina liste.
private:
  void kopiraj(const NLista& lst);   // Kopiranje druge liste.
  void brisi();                      // Pranjenje liste.
public:                                                // Konstruktori:
  NLista() { prvi = posl = 0; duz = 0; }               // - prazna lista,
  NLista(int b)                                        // - konverzija,
    { prvi = posl = new Elem(b); duz = 1; }
  NLista(const NLista& lst) { kopiraj(lst); }          // - kopiranje.
  ~NLista() { brisi(); }                               // Unitavanje.
  NLista& operator=(const NLista& lst) {               // Dodela vrednosti.
    if (this != &lst) { brisi(); kopiraj(lst); }
    return *this;
  }
  int duzina() const { return duz; }                   // Duina liste.
  virtual NLista& operator+=(int b) {                  // Dodavanje broja.
    Elem* novi = new Elem(b); duz++;
    posl = (!prvi ? prvi : posl->sled) = novi;
    return *this;
  }
  NLista& operator+=(const NLista& lst);               // Dodavanje liste.
  friend ostream& operator<<(ostream&, const NLista&); // Pisanje.
};

#endif
