// osoba4.h - Klasa osoba.

#ifndef _osoba4_h_
#define _osoba4_h_

#include "datum3.h"
#include <cstring>
#include <iostream>
using namespace std;

class Osoba {
  char* ime;                                     // Ime.
  Datum rodj;                                    // Datum rodenja.
  Osoba(const Osoba&) {}                         // Ne sme da se kopira.
  void operator=(const Osoba&) {}                // Ne sme da se dodeljuje.
public:
  Osoba(const char* ii, const Datum& rr) {       // Konstruktor.
    ime = strcpy(new char [strlen(ii)+1],ii);
    rodj = rr;
  }
  virtual ~Osoba() { delete [] ime; }            // Destruktor.
  Osoba& staviIme(const char* ii) {              // Menjanje imena.
    delete [] ime;
    ime = strcpy(new char [strlen(ii)+1],ii);
    return *this;
  }
  Osoba& staviRodj(const Datum& rr)              // Menjanje datuma rod.
    { rodj = rr; return *this; }
  const char* dohvIme() const { return ime; }    // Dohvatanje imena.
  const Datum& dohvRodj() const { return rodj; } // Dohvatanje dat. rod.
protected:
  virtual void pisi(ostream& it) const           // Pisanje.
    { it << ime << " (" << rodj << ')'; }
  friend ostream& operator<<(ostream& it, const Osoba& oso)
    { oso.pisi(it); return it; }
};

#endif
