// predmet2.h - Apstraktna klasa predmeta.

#ifndef _predmet2_h_
#define _predmet2_h_

#include <iostream>
using namespace std;

namespace Zbirke {
  class Predmet {
    static int posId;                        // Poslednji identifikator.
    int id;                                  // Identifikator predmeta.
  public:
    Predmet() { id = ++posId; }              // Nov predmet dobija nov broj.
    Predmet(const Predmet&)                  // Kopija dobija nov broj.
      { id = ++posId; }
    virtual ~Predmet() {}                    // Virtuelan destruktor.
    Predmet& operator=(const Predmet&)       // Levom operandu se
      { return *this; }                      //   ne menja broj.
    int idBr() const { return id; }          // Identifikacioni broj.
    virtual Predmet* kopija() const =0;      // Kopiranje.
  private:
    virtual void pisi(ostream& it) const =0; // Pisanje.
    friend ostream& operator<<(ostream& it, const Predmet& p)
      { p.pisi(it); return it; }
  };
} // namespace

#endif
