// proizvodjac.h - Genericka klasa proizvodaca.

#ifndef _proizvodjac_h_
#define _proizvodjac_h_

#include "akter.h"
#include "skladiste.h"

template <typename T>
class Proizvodjac: public Akter {
  Skladiste<T>* sklad;                        // Odredino skladite.
public:
  Proizvodjac(Skladiste<T>* s, double tMin=0, // Inicijalizacija.
              double tMax=1): Akter(tMin, tMax)
    { sklad = s; }
  void radnja() {                             // Radnje proizvodaca.
    cout << *this << ": ";
    try {
      T t = T();
      sklad->stavi(t);
      cout << "stavio " << t << endl;
    } catch (GPuno g) { cout << g << endl; }
  }
};

#endif
