// pvozilo.C - Metode klase putnickih vozila.

#include "pvozilo.h"

PVozilo::PVozilo(const Osoba* vozac, float sopTez, int k) // Konstruktor.
    : Vozilo(vozac,sopTez) {
  osobe = new const Osoba* [kap = k];
  for (int i=0; i<kap; osobe[i++]=0);
}

bool PVozilo::operator+=(const Osoba* putnik) {     // Ulazak putnika.
  int i = 0; while (i<kap && osobe[i]) i++;
  if (i == kap) return false;
  osobe[i] = putnik; return true;
}

float PVozilo::tezina() const {                     // Ukupna teina.
  float t = Vozilo::tezina();
  for (int i=0; i<kap; i++)
    if (osobe[i]) t += osobe[i]->dohvTez();
  return t;
}

bool PVozilo::operator-=(const Osoba* putnik) {     // Izlazak putnika.
  int i = 0; while (i<kap && osobe[i]!=putnik) i++;
  if (i == kap) return false;
  osobe [i] = 0; return true;
}

void PVozilo::pisi(ostream& it) const {             // Pisanje.
  Vozilo::pisi(it);
  it << '{';
  bool prvi = true;
  for (int i=0; i<kap; i++)
    if (osobe[i]) {
      if (!prvi) cout << '|';
      if (osobe[i]) it << *osobe[i];
      prvi = false;
    }
    it << '}';
}
