// radnik1.h - Klasa radnika.

#ifndef _radnik1_h_
#define _radnik1_h_

#include "proizvod1.h"
#include "masina.h"
#include <iostream>
#include <cstring>
using namespace std;

namespace Fabrika {
  class GNemaMasinu {  // KLASA GREAKA: Radnik nema mainu.
    char* ime; int id; // Ime i identifikator problematicnog radnika.
    void operator=(const GNemaMasinu&) {}    // Ne sme da se dodeljuje.
  public:
    GNemaMasinu(const char* iime, int iid) { // Inicijalizacija.
      ime = strcpy(new char [strlen(iime)+1], iime);
      id = iid;
    }
    GNemaMasinu(const GNemaMasinu& g) {      // Konstruktor kopije.
      ime = strcpy(new char [strlen(g.ime)+1], g.ime);
      id = g.id;
    }
    ~GNemaMasinu() { delete [] ime; }        // Destruktor.
    friend ostream& operator<<(ostream& it, const GNemaMasinu& g) {
      return it << "\n*** Radniku " << g.ime << ", id " << g.id
                << ", nije dodeljena masina ***\n\a";
    }
  }; // class GNemaMasinu

  class Radnik {         // KLASA RADNIKA:
    static int posId;    // Poslednji identifikator.
    int id; char* ime;   // Identifikator i ime radnika.
    Masina* mas;         // Maina koju radnik koristi.
    int br;              // Broj napravljenih proizvoda na masini.
    Radnik(const Radnik&) {}                 // Ne sme da se kopira.
    void operator=(const Radnik&) {}         // Ne sme da se dodeljuje.
  public:
    Radnik(const char* iime) {               // Inicijalizacija.
      id = ++posId; mas=0;
      ime = new char [strlen(iime)+1]; strcpy(ime,iime);
    }
    ~Radnik() {delete [] ime;} // Unitavanje (radnik nije vlasnik maine!)
    const char* dohvIme() const { return ime; } // Dohvatanje imena.
    int dohvId() const { return id; }        // Dohvatanje identifikatora
    Radnik& operator+=(Masina* m)            // Pridruivanje maine.
      { mas = m; br = 0; return *this; }
    int broj() const {                       // Broj napravljenih proizvoda.
      if (!mas) throw GNemaMasinu(ime, id);
      return br;
    }
    Proizvod* napravi() {                    // Napravi proizvod.
      if (!mas) throw GNemaMasinu(ime, id);
      br++; return mas->napravi();
    }
    friend ostream& operator<<(ostream& it, const Radnik& r) { // Pisanje.
      it << r.ime << '/' << r.id;
      if (r.mas) it << '(' << r.mas->vrsta() << ',' << r.br << ')';
      return it;
    }
  }; // class Radnik
} // namespace Fabrika

#endif
