// sef.h  Klasa efova.

#ifndef _sef_h_
#define _sef_h_

#include "radnik2.h"
#include "firmagr.h"

namespace Trgovina {
  class Sef: public Radnik {
    Radnik** potcinjeni;        // Niz potcinjenih radnika.
    int maxPot, brPot;          // Najveci i trenutni broj potcinjenih.
  public:
    Sef(const char* ime, double procenat, int k=3): // Inicijalizacija.
        Radnik(ime, procenat) {
      potcinjeni = new Radnik* [maxPot = k];
      brPot = 0;
    }
    ~Sef() { delete [] potcinjeni; }    // Destruktor.
    Sef&  dodeli(Radnik* r) {           // Dodeljivanje potcinjenog.
      if (brPot == maxPot) throw GPrevise();
      potcinjeni[brPot++] = r;
      return *this;
    }
    double prihod() const;              // Ostvareni prihod.
  }; // class
} // namespace

#endif
