// sekvenca.h - Klasa sekvenci.

#ifndef _sekvenca_h_
#define _sekvenca_h_

#include "naredba.h"

namespace Naredbe {
  class Sekvenca: public Naredba {
    struct Elem {                             // Element sekvence:
      Naredba* nar;                           // - sadrana naredba,
      Elem* sled;                             // - sledeci element liste,
      Elem(Naredba* n) { nar = n; sled = 0; } // - konstruktor,
      ~Elem() { delete nar; delete sled; }    // - destruktor.
    }; // struct Elem

    Elem *prva, *posl;                        // Prva i poslednja naredba.
    void kopiraj(const Sekvenca&);            // Kopiranje u objekat.
    void pisi(ostream&) const;                // Pisanje.
  public:
    Sekvenca() { prva = posl = 0; }              // Prazna sekvenca.
    Sekvenca(const Sekvenca& s) { kopiraj(s); }  // Konstruktor kopije.
    ~Sekvenca() { delete prva; }                 // Unitavanje.
    Sekvenca& operator=(const Sekvenca& s) {     // Dodela vrednosti.
      if (this != &s) { delete prva; kopiraj(s); }
      return *this;
    }
    Sekvenca& operator+=(const Naredba& n) {     // Dodavanje naredbe.
      posl = (!prva ? prva : posl->sled) = new Elem(n.kopija());
      return *this;
    }
    void radi() const;                           // Izvravanje.
    Sekvenca* kopija() const { return new Sekvenca(*this); } // Kopiranje.
  }; // class Sekvenca
} // namespace Naredbe

#endif
