// skladiste.h - Genericka klasa skladita stvari.

#ifndef _skladiste_h_
#define _skladiste_h_

#include <iostream>
using namespace std;

class GPuno {};                     // KLASA GREAKA: Skladite je puno.
inline ostream& operator<<(ostream& it, const GPuno&)
  { return it << "*** Skladiste je puno! ***"; }

class GPrazno {};                   // KLASA GREAKA: Skladite je prazno.
inline ostream& operator<<(ostream& it, const GPrazno&)
  { return it << "*** Skladiste je prazno! ***"; }

template <typename T>               // GENERICKA KLASA SKLADITA:
class Skladiste {
  T* niz;                           // Niz stvari.
  int kap, duz;                     // Kapacitet i popunjenost niza.
  int prvi, posl;                   // Indeks prve i poslednje stvari.
  void kopiraj(const Skladiste& s); // Kopiranje u objekat.
  void brisi() { delete [] niz; }   // Brisanje objekta.
public:
  explicit Skladiste(int k=10) {    // Stvaranje praznog skladita.
    niz = new T [kap = k];
    prvi = posl = duz = 0;
  }
  Skladiste(const Skladiste& s) { kopiraj(s); } // Konstruktor kopije.
  ~Skladiste() { brisi(); }                     // Destruktor.
  Skladiste& operator=(const Skladiste& s) {    // Dodela vrednosti.
    if (this != &s) { brisi(); kopiraj(s); }
    return *this;
  }
  void stavi(const T& t) {          // Stavljanje u skladite.
    if (duz == kap) throw GPuno();
    niz[posl++] = t;
    if (posl == kap) posl = 0;
    duz++;
  }
  T uzmi() {                        // Uzimanje iz skladita.
    if (duz == 0) throw GPrazno();
    T t = niz[prvi++];
    if (prvi == kap) prvi = 0;
    duz --;
    return t;
  }
};

template <typename T>                            // METODA KLASE SKLADITA:
void Skladiste<T>::kopiraj(const Skladiste& s) { // Kopiranje u objekat.
  niz = new T [kap = s.kap];
  for (int i=0; i<kap; i++) niz[i] = s.niz[i];
  prvi = s.prvi; posl = s.posl; duz = s.duz;
}

#endif
