// tekst3.h - Klasa tekstova.

#ifndef _tekst3_h_
#define _tekst3_h_

#include "objekat.h"
#include <cstring>
using namespace std;

class Tekst: public Obj {
  char* tks;                                   // Sadraj objekta.
  bool jednako(const Obj& obj) const           // Da li su jednaki?
    { return strcmp(tks, ((Tekst&)obj).tks) == 0; }
  void pisi (ostream& it) const                // Pisanje.
    { it << '[' << (tks ? tks : "") << ']'; }
  void citaj(istream& ut);                     // Citanje.
  void kopiraj(const char* niz);               // Kopiranje.
public:
  Tekst(const char* niz="") { kopiraj(niz); }  // Inicijalizacija nizom.
  Tekst(const Tekst& t): Obj(t)                // Inicijalizacija tekstom.
    { kopiraj(t.tks); }
  ~Tekst() { delete [] tks; }                  // Unitavanje.
  Tekst& operator=(const Tekst& t) {           // Dodela vrednosti.
    if (this != &t) { delete [] tks; Obj::operator=(t); kopiraj(t.tks); }
    return *this;
  }
  Tekst* kopija() const { return new Tekst(*this); } // Kopiranje.
};

#endif
