// tvozilo.h - Klasa teretnih vozila.

#ifndef _tvozilo_h_
#define _tvozilo_h_

#include "vozilo1.h"

class TVozilo: public Vozilo {
  float nosivost, tovar;                       // Nosivost i tezina tovara.
public:
  TVozilo(const Osoba* vozac, float sopTez, float nosivost) // Konstruktor.
    : Vozilo(vozac,sopTez)
    { this->nosivost=nosivost; tovar=0; }
  char vrsta() const { return 'T'; }          // Oznaka vrste vozila.
  bool operator+=(float tez) {                // Stavljanje tovara.
    if (tovar+tez > nosivost) return false;
    tovar += tez; return true;
  }
  bool operator-=(float tez) {                // Skidanje tovara.
    if (tovar-tez < 0) return false;
    tovar -= tez;  return true;
  }
  float tezina() const                        // Ukupna teina.
    { return Vozilo::tezina() + tovar; }
private:
  void pisi(ostream& it) const {              // Pisanje.
    Vozilo::pisi(it);
    it << '(' << tovar << '/' << nosivost << ')';
  }
};

#endif
