// uredjaj.h - Klasa elektricnih uredaja.

#ifndef _uredjaj_h_
#define _uredjaj_h_

#include "potrosac1.h"
#include <iostream>
#include <cstring>
using namespace std;

namespace Potrosaci {
  class Uredjaj: public Potrosac {
    char* naz;                               // Naziv uredaja.
    double sna;                              // Snaga uredaja.
    void kopiraj(const char* n, double s) {  // Kopiranje u objekat.
      naz = new char [strlen(n)+1];
      strcpy(naz, n); sna = s;
    }
    void brisi() { delete [] naz; }          // Brisanje objekta.
    void pisi(ostream&it) const              // Pisanje.
      { it << naz << '(' << sna << ')'; }
  public:
    Uredjaj(const char* n, double s)         // Inicijalizacija.
      { kopiraj(n, s); }
    Uredjaj(const Uredjaj& u)                // Konstruktor kopije.
      { kopiraj(u.naz,u.sna); }
    ~Uredjaj() { brisi(); }                  // Destruktor.
    Uredjaj& operator=(const Uredjaj& u) {   // Dodela vrednosti.
      if (this != &u) { brisi(); kopiraj(u.naz,u.sna); }
      return *this;
    }
    double snaga() const { return sna; }     // Snaga uredaja.
    Uredjaj* kopija() const                  // Kopiranje.
      {return new Uredjaj(*this);}
  }; // class
} // namespace

#endif
