// voz1.C - Metode i funkcije uz klasu vozova.

#include "voz1.h"

namespace Vozovi1 {
  void Voz::kopiraj(const Voz& v) {          // Kopiranje u objekat.
    ime = new char [strlen(v.ime)+1];
    strcpy(ime, v.ime);
    prvi = posl = 0;
    for (Elem* tek=v.prvi; tek; tek=tek->sled) {
      Elem* novi = new Elem(tek->vozilo->kopija());
      posl = (!prvi ? prvi : prvi->sled) = novi;
    }
  }

  void Voz::brisi() {                        // Brisanje objekta.
    while (prvi)
      {Elem* stari=prvi; prvi=prvi->sled; delete stari;}
    posl = 0; delete [] ime;
  }

  Voz& Voz::operator+=(const Lokomot& lok) { // Dodavanje lokomotive.
    if (prvi) throw GImaLok();
    posl = prvi = new Elem(lok.kopija());
    return *this;
  }

  Voz& Voz::operator+=(const PVagon& pvag) { // Dodavanje putn. vagona.
    if (!prvi) throw GNemaLok();
    if (ukTezVoza()+pvag.ukTezina() > ((Lokomot*)prvi->vozilo)->snaga())
      throw GTezakVoz();
    posl = posl->sled = new Elem(pvag.kopija());
    return *this;
  }

  float Voz::ukTezVoza() const {             // Ukupna teina voza.
    float t = 0;
    for (Elem* tek=prvi; tek; tek=tek->sled) t += tek->vozilo->ukTezina();
    return t;
  }

  ostream& operator<<(ostream& it, const Voz& v) { // Pisanje.
    it << v.ime << '(' << v.ukTezVoza() << ','
       << PVagon::dohvatiSrTezPut() << ')' << endl;
    for (Voz::Elem* tek=v.prvi; tek; tek=tek->sled)
      it << *tek->vozilo << endl;
    return it;
  }
} // namespace
