// vozilo.h  Apstraktna klasa vozila.

#ifndef _vozilo_h_
#define _vozilo_h_

#include "osoba3.h"
#include <iostream>
using namespace std;

class Vozilo { 
  float sopTez;                                   // Sopstvena teina.
  const Osoba *vozac;                             // Vozac vozila.
  Vozilo(const Vozilo&) {}                        // Ne sme da se kopira.
  void operator=(const Vozilo&) {}                // Ne sme da se dodeljuje.
public:
  Vozilo(const Osoba* vozac, float sopTez)        // Konstruktor.
    { this->vozac = vozac; this->sopTez=sopTez; }
  virtual ~Vozilo() {}                            // Virtuelan destruktor.
  virtual char vrsta() const =0;                  // Oznaka vrste vozila.
  virtual float tezina() const                    // Ukupna teina.
    { return sopTez + vozac->dohvTez(); }
protected:
  virtual void pisi(ostream& it) const   // Pisanje.
    { it << vrsta() << '[' << *vozac << ',' << sopTez << ']'; }
  friend ostream& operator<<(ostream& it, const Vozilo& v)
    { v.pisi(it); return it; }
};

#endif
