// vozilo2.h - Klasa vozila.

#ifndef _vozilo2_h_
#define _vozilo2_h_

#include <iostream>
using namespace std;

namespace Vozovi1 {
  class Vozilo {
    static int posId;                   // Poslednji identifikator.
    int id;                             // Identifikator vozila.
    float sopTez;                       // Sopstvena teina vozila.
  public:
    Vozilo(float tez)                   // Novom vozilu novi identifikator.
      { id = ++posId; sopTez = tez; }
    Vozilo(const Vozilo& v)             // Kopiji novi identifikator.
      { id = ++posId; sopTez = v.sopTez; }
    Vozilo& operator=(const Vozilo&v)   // Levom operandu se ne menja ident.
      { sopTez = v.sopTez; }
    float sopTezina() const { return sopTez; } // Sopstvena teina.
    virtual char vrsta() const =0;             // Oznaka vrste.
    virtual float ukTezina() const =0;         // Ukupna teina.
    virtual Vozilo* kopija() const =0;         // Kopiranje.
  protected:
    virtual void pisi(ostream& it) const       // Pisanje.
      { it << vrsta() << id << '[' << sopTez << ']'; }
    friend ostream& operator<<(ostream& it,
        const Vozilo& v) { v.pisi(it); return it; }
  }; // class
} // namespace

#endif
