// zapis.h  Klasa zapisa o artiklu.

#include <cstring>
#include <iostream>
using namespace std;

class Zapis {
  char *naz, *jed;   // Naziv i jedinica mere.
  double kol, cen;   // Kolicina i cena.
  void kopiraj(const Zapis& z) {                  // Kopiranje u objekat.
    naz = new char [strlen(z.naz)+1]; strcpy(naz, z.naz);
    jed = new char [strlen(z.jed)+1]; strcpy(jed, z.jed);
    kol = z.kol; cen = z.cen;
  }
  void brisi() { delete [] naz; delete [] jed; }  // Brisanje objekta.
public:
  Zapis(const char* n, const char* j, double c) { // Stvaranje objekta.
    naz = new char [strlen(n)+1]; strcpy(naz, n);
    jed = new char [strlen(j)+1]; strcpy(jed, j);
    kol = 0; cen = c;
  }
  Zapis(const Zapis& z) { kopiraj(z); }           // Kostruktor kopije.
  ~Zapis() { brisi(); }                           // Destruktor.
  Zapis& operator=(const Zapis& z) {              // Dodela vrednosti.
    if (this != &z) { brisi(); kopiraj(z); }
    return *this;
  }                                               // Dohvatanje:
  const char* naziv() const { return naz; }       // - naziva,
  double kolicina() const { return kol; }         // - kolicine,
  const char* jedMere() const { return jed; }     // - jedinice mere,
  double cena() const { return cen; }             // - cene.
  double vrednost() const { return cen * kol; }   // Izracunavanje vrednosti
  bool operator+=(double dk) {                    // Promena kolicine.
    if (kol + dk < 0) return false;
    kol += dk; return true;
  }
  friend ostream& operator<<(ostream& it, const Zapis& z) { // Pisanje.
    return it << z.naz << ": " << z.kol << z.jed << " x " 
              << z.cen << "din = " << z.vrednost() << "din"; 
  }
};
